<?php

class Action_Filesys extends Action_Common
{
	private function copy_file($srcfile, $dstfile, $mode)
	{
		if (empty($srcfile) || empty($dstfile) || empty($mode))
			throw new Mirror_Cmd_Exception("Invalid arguments for upload file");

		$content = @file_get_contents($srcfile);
		if ($content === false)
			throw new Mirror_Exception("Could not open source file: $srcfile.");

		mkdir(dirname($dstfile), 0755, true);

		$written = file_put_contents($dstfile, $content);
		if ($written === false)
			throw new Mirror_Exception("Could not write target file: $dstfile");

		if (!chmod($dstfile, $mode))
			throw new Mirror_Exception("Unable to set permissions to file: $dstfile");
	}

	public function upload($srcfile, $dstfile, $mode)
	{
		$this->copy_file($srcfile, $dstfile, $mode);
	}

	public function download($srcfile, $dstfile, $mode)
	{
		$this->copy_file($srcfile, $dstfile, $mode);
	}

	public function exec($cmd)
	{
		if (empty($cmd))
			throw new Mirror_Exception("Invalid arguments for remote execution");

		$stdio  = passthru($cmd);

		stream_set_blocking($stdio, true);
		while ($line = fgets($stdio)) {
                         flush();
                         echo $line;
                }

		fclose($stdio);
	}
}
