<?php

require_once("Product/Common.php");

interface Product_Interface
{
	// Getting info about accesible Plesk releases
	public function get_release_list();

	// Getting info about supported oses for selected release
	public function get_os_list($release);

	// Gathering info from *.inf3 config files.
	// And convert Xml records into array.
	public function get_data();

	// Gathering info for described in local config oses only
	// Required for correct working of updater/pusher.
	public function get_info(Config $config);

	// Generate commands for sync the repository
	public function get_cmd($data, $cmd_url, $path);
}

class Product
{
	private static $instance = array();

	private static function getInstance($class)
	{
		if (!self::$instance[$class])
			self::$instance[$class] = new $class;
		return self::$instance[$class];
	}

	public static function factory($type)
	{
		$class_name = "Product_" . $type;
		require_once("Product/$type.php");
		$obj = self::getInstance($class_name);
//		$obj = new $class_name();
		return $obj;
	}
}
