<?php

class Sync_Push extends Sync_Common
{
	public function update()
	{
		global $options;
		if (empty($options['repos']))
			throw new Mirror_Cmd_Exception("Please specify source repository at first");

		$opts = getCmdOptions();
		$path = $opts->get_path();

		$product = Product::factory(Types::PLESK);

		// Use config from local repository
		$config  = new Config($opts->get_cfg_file());

		// Check existing described Releases/OSes in remote repository
		$config->check();

		// Create config and execute it
		$cmds = $this->get_cmds($product, $config, $path);

		$this->create(Types::PUSH, $cmds);
		$this->execute(Types::PUSH);

		// Add merged configurations into remote Plesk config
		$product->upload_config(Types::MERGE, $config);

		$addons = Product::factory(Types::ADDONS);
		$addons->upload_config(Types::MERGE, $config);

		$common = new Product_Common();
		$common->upload_config(Types::MERGE, $config);
	}
}
