<?php

class Sync_Update extends Sync_Common
{
	public function update()
	{
		$opts = getCmdOptions();
		$path = $opts->get_path();

		if ($opts->get_src_host())
			throw new Mirror_Cmd_Exception("Please use original Plesk repository for this action, i.e. remove the --src-host option.");

		$product = Product::factory(Types::PLESK);
		$config  = new Config($opts->get_cfg_file());

		// Check existing described Releases/OSes in remote repository
		$config->check();

		// Create config and execute it
		$cmds = $this->get_cmds($product, $config, $path);

		// Sync repositories
		$this->create(Types::UPDATE, $cmds);
		$this->execute(Types::UPDATE);
		$config->export();

		// Strip and upload configs
		$product->upload_config(Types::STRIP, $config);

		$addons = Product::factory(Types::ADDONS);
		$addons->upload_config(Types::STRIP, $config);

		$common = new Product_Common();
		$common->upload_config(Types::STRIP, $config);
	}
}
