<?php

function usage($progname = 'progname')
{
	echo "Usage:\n";
	echo "     Commands for working with Plesk repository:\n";
	echo "          $progname show-all-releases [--win] [--src-host=<URL to source repository>]\n";
	echo "          $progname os-list --release=<Plesk release> [--win] [--src-host=<URL to source repository>]\n";
	echo "\n";
	echo "     Commands for configuring destination repository:\n";
	echo "          $progname cfg --add    --release=<Plesk release> [--os=<OS name|all>|--win] [--cfg-file=<config>]\n";
	echo "          $progname cfg --remove --release=<Plesk release> [--os=<OS name|all>|--win] [--cfg-file=<config>]\n";
	echo "          $progname cfg --check [--cfg-file=<config>] [--win] [--src-host=<URL to source repository>]\n";
	echo "          $progname cfg --import --path=<repository>\n";
	echo "          $progname cfg --export --path=<repository>\n";
	echo "\n";
	echo "     Common commands:\n";
	echo "          $progname update --path=<Plesk destination repository> [--win] [--cfg-file=<config>] [--private-key=<key> --public-key=<key>]\n";
	echo "\n";
	echo "          $progname push [--src-host=<URL to source repository>] [--win] --path=<Plesk destination repository> [--cfg-file=<config>] [--private-key=<key> --public-key=<key>]\n";
	echo "\n";
	echo "          $progname version\n";
	echo "          $progname -h|--help|help\n";
	echo "\n";
	echo "     Options:\n";
	echo "          --path   The path to repository in format: [[login[:password@]]host:[port]]/path/to/repository\n";
	echo "                   E.g.:\n";
	echo "                      Custom user/password/port:\n";
	echo "                         --path=root:blabla@myhost.com:344/path/to/repository\n";
	echo "\n";
	echo "                      Custom user:\n";
	echo "                         --path=root@myhost.com:/path/to/repository\n";
	echo "\n";
	echo "                      Custom port. But your username and ssh keys will be used:\n";
	echo "                        --path=myhost.com:4322/path/to/repository - here your username will be used.\n";
	echo "\n";
	echo "                      Custom user/password but default port:\n";
	echo "                        --path=root:blabla@myhost.com:/path/to/repository\n";
	echo "\n";
	echo "                      Working with local repository:\n";
	echo "                         --path=/path/to/repository\n";
	echo "\n";
	echo "         --src-host The source repository path in rsync utility format (man rsync)\n";
	echo "                   E.g:\n";
	echo "                      Getting data from repository over rsync daemon:\n";
	echo "                          --src-host=rsync://[user@]host[:port]/path\n";
	echo "\n";
	echo "                      Getting data from repository over ssh protocol:\n";
	echo "                          --src-host=[user@]host:/path\n";
	echo "\n";
	echo "                      Getting data from local repository:\n";
	echo "                          --src-host=/path\n";
	echo "\n";
	echo "        --win       Do mirror for Microsoft Windows Plesk repository\n";
	echo "\n";
	echo "Please follow the Plesk Knowledge Base for additional info and examples:\n";
	echo "     http://kb.plesk.com/113337\n";
	echo "\n";
}
